function [t,W,FI,mu,m]=HTM(X,L,Kmax,M,delta,width,MAXC,p)
% function [t,W,FI,mu,m]=HTM(X,L,Kmax,M,delta,width,MAXC,p)
% delta could be 0.000000000001,width cound be 2^-2...? 
% Kmax:maximal number of latent points
% M: number of basis function
% delta: positive small number
% width: width of Gaussian basis function
% MAXC: MAXCOUNT, p: power of the Euclidean distance
%  Return:
% t: L-by-Kmax matrix of latent points
% W: weight matrix
% FI: activiation basis matrix
% mu: centers of basis functions in latent space
% m=FI*W


%X=[xx;yy];
[D N]=size(X);
%%% initialization:
K=2^L; %%% note !?
W=rand(M,D);
%% initialize basis function centres UNIFORMLY across the latent space %%
%% with NL nonlinear and L linear and 1 bias %%
NL=M-L-1;
[mu]=grid_generate(L,NL,1,7);
mu=scale(mu); % scale to [-1 1];
while K<=Kmax
[t] = grid_generate(L, K, 1, 7 );
                   % L N mode seed
[t]=scale(t);
% calculate basis function Mapping matrix FI
FI=ones(K,M);
for i=1:K
    for j=1:NL
        d=sum((t(:,i)-mu(:,j)).^2);
        FI(i,j)=exp(-d/2*width);
    end
    for j=NL+1:M-1
        FI(i,j)=t(j-NL,i);
    end
end
% calculate mapping matrix m: K-by-D
m=FI*W;
    
count=0;
while (count<MAXC)
    % calculate Euclidean Distance Matrix Dis(i,k)=dist(Xi,mk): N-by-K
       for i=1:N
          for k=1:K
              Dis(i,k)=sqrt(sum((X(:,i)-m(k,:)').^2));
          end
       end
       % Update mapping matrix m by Harmonic k-means
       A=(sum(Dis.^-p,2)).^2;
       B=Dis.^(p+2);
       for k=1:K
           temp=0;temp2=zeros(D,1);
          for i=1:N
              temp=temp+(B(i,k)*A(i))^-1;
              temp2=temp2+((B(i,k)*A(i))^-1)*X(:,i);
          end
          m(k,:)=(temp2/temp)';
      end
        count=count+1;
end % end while
% Update W
 [U,S,V]=svd(FI'*FI+delta*eye(M));           
  S=diag(diag(S).^-1);
  IM=V*S*U'; % inverse Matrix IM
  W=IM*FI'*m;            
  K=K+1;
  
  %%% plot current result %%%
%subplot(2,1,1);
switch(D)
    case 2
    plot(X(1,:),X(2,:),'r+');
    hold on;
    plot(m(:,1),m(:,2),'b*-');
    pause(0);
    hold off;
    case 3
    plot3(X(1,:),X(2,:),X(3,:),'r+');
    hold on;
    plot3(m(:,1),m(:,2),m(:,3),'b*');
    pause(0);
    hold off;
otherwise
end
%%%%%%%%%%%%%%%%%%%%%%%%%%    
end % end while                        