function [mux,varx,beta,pcm,vary,like] = MIMOcwml(xx,yy,M,iter,epsx,epsy)
% function [mux,varx,beta,pcm,vary,like] = MIMOcwml(xx,yy,M,iter,epsx,epsy)

[I N]=size(xx);
O=length(yy(:,1));
mux=zeros(I,M);
varx=zeros(I,M);
muy=zeros(O,1);
MUY=zeros(N,M,O);
vary=zeros(O,M);
beta=zeros(I+1,M,O);
q=2*pi;
sq=sqrt(q);
sqi=sq^I;
sqo=sq^O;
f=ones(I+1,N);
minx=zeros(1,I); % to store the minimum of each input dimension
maxx=zeros(1,I); % to store the maximum of each input dimension
miny=zeros(1,O);
maxy=zeros(1,O);
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
posteriors=zeros(N,M);
pcm=zeros(1,M);
B=zeros(I+1,I+1);
a=zeros(I+1,1);
f(2:I+1,:)=xx;
minx=min(xx,[],2);
maxx=max(xx,[],2);
miny=min(yy,[],2);
maxy=max(yy,[],2);
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing varx vary
varx=repmat((maxx-minx),1,M);
vary=repmat((maxy-miny),1,M);
% use k-means to initialize cluster centers
if M==1
    mux=mean(xx')';
else
[idx c]=kmeans(xx',M);
mux=c';
end
pcm(1,:)=1/M;
%%%%%%%%%%%%%%%%%%%%%%%
like=[];
msecurve=[];
%%%%%%%%%%%%%%%% drawing space %%%%%%
nplot=40;
if I==1
xplot=linspace(minx(1),maxx(1),nplot);
end

if I==2
    xplot1=linspace(minx(1),maxx(1),nplot);
    xplot2=linspace(minx(2),maxx(2),nplot);
    [x1,x2]=meshgrid(xplot1,xplot2);
end
%%%%%%%%%%%%%%%%%%% load local minima condition %%%%%
%load 4clump_minima;
%load clump_minima
%load clump_minima2;
%load 3Dclump_minima;
%%%%%%%%%%%%%%%%%%% load LMS CWM's training result %%%
% load sseMIMO mux beta pcm varx;
%  [idx c]=kmeans(xx',M,'start',mux');
% mux=c';
%%%%%%
epoch=1;
% Start training
while(epoch<=iter)
 % E-Step
 %%%% draw %%%%%%%%%%%%%%%%%%%%%%
if I==2
subplot(3,1,1);
    for m=1:M
         mu=mux(:,m); 
             temp=diag(varx(:,m));
             tempi=varx(:,m).^-1;
             p=exp(-0.5*(tempi(1)*(x1-mu(1)).^2+tempi(2)*(x2-mu(2)).^2))/(sqrt((2*pi).^2)*sqrt(det(temp)))*pcm(m); % p(x,cm)
             hold on;
             view(3);
             surf(x1,x2,p);
             axis tight;
             hold off;
         end
    % pause(0);
      %pause
   end
if I==1
    temp=0;
    hold off;
    subplot(3,1,1);
    for m=1:M
        p=pcm(m)*exp(-0.5*(xplot-mux(m)).^2/varx(m))/(sqrt(2*pi*varx(m)));
        plot(xplot,p);
        hold on
     end
   pause(0.01);     
end % end if
hold off;
% %%%%%%%%%%% End of drawing %%%%%%%%%%%%%%%%%%%%%
for m=1:M
px_cm(:,m)=exp(-0.5*((xx-repmat(mux(:,m),1,N)).^2)'*(varx(:,m).^-1))/(sqrt(prod(varx(:,m)))*(sqi));
end
for i=1:O
MUY(:,:,i)=f'*beta(:,:,i);
end
for m=1:M
    for i=1:O
     muy2(:,i)=MUY(:,m,i);
   end
py_xcm(:,m)=exp(-0.5*((yy-muy2').^2)'*(vary(:,m).^-1))/(sqrt(prod(vary(:,m)))*(sqo));
end
posteriors=py_xcm.*px_cm.*(repmat(pcm,N,1));
posteriors=posteriors./(repmat(sum(posteriors,2),1,M));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% M-step
 s=sum(posteriors);
 pcm=s/N;
mux=(xx*posteriors)./(repmat(s,I,1));
for m=1:M
varx(:,m)=((xx-repmat(mux(:,m),1,N)).^2)*posteriors(:,m)./(repmat(s(m),I,1));
end
varx=varx+ones(I,M)*epsx;
for m=1:M
%  calculate  [Bij] [a]
      for i=1:I+1
          for j=1:I+1
                 temp3=0;
              for n=1:N
                  temp3=temp3+f(i,n)*f(j,n)*posteriors(n,m);
              end
              B(i,j)=temp3/s(m);
          end
      end
      %  beta=inv(B)*a;
 %% update beta USING SVD %%
       [U,W,V]=svd(B);           
        W=diag(diag(W).^-1);
        B=V*W*U';
    for k=1:O
       for i=1:I+1
              temp3=0;
               for n=1:N
                  temp3=temp3+yy(k,n)*f(i,n)*posteriors(n,m);
               end
              a(i)=temp3/s(m);
        end
        beta(:,m,k)=B*a;
   end
end

for i=1:O
MUY(:,:,i)=f'*beta(:,:,i);
end
for m=1:M
    for i=1:O
     muy2(:,i)=MUY(:,m,i);
   end
vary(:,m)=((yy-muy2').^2)*posteriors(:,m)./(repmat(s(m),O,1));
end
vary=vary+ones(O,M)*epsy;
%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%    %% calculate log likelihood
     like(epoch)= sum(log((py_xcm.*px_cm)*pcm'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %  calculate MSE
% %   calculate <y_x>
y_x=zeros(O,N);
   for n=1:N
     temp2=0;
     for m=1:M
         temp2=temp2+px_cm(n,m)*pcm(m);
         for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
         end
       y_x(:,n)=y_x(:,n)+muy*px_cm(n,m)*pcm(m);
     end
     y_x(:,n)=y_x(:,n)/temp2;
 end
  
   E=sum(sum((yy-y_x).^2))/N; % MSE
   msecurve(epoch)=sqrt(E); % RMSE
%    %%%%%%% plot %%%%%%
 subplot(3,1,2);
   plot(msecurve,'b');
     subplot(3,1,3);
   plot(like,'r');
   pause(0.01);
%    %%%%%%%%%%%%%%%%%%%%%%
epoch=epoch+1;
end