function [W]=SIRrep(xx,yy,L,min_D,max_D,L2)
% function [W]=SIRrep(xx,yy,L,min_D,max_D,L2)
% xx: training data (column matrix), yy: responding class labels,
% from 1 to L
% L: number of classes
% max_D: maximal withinclass distance threshold
% L2: output dimension

%% generate data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% parameters which seem to work for the first dataset
% phir=100 phia=0.001
%%%
%clear all;
% xx=zeros(2,200);yy=zeros(1,200); mu1=[0;0]; mu2=[0.5;0.5];mu3=[-.8; -.8];
%  xx(:,1:100)=sqrt(0.1)*randn(2,100);
% xx(:,101:200)=sqrt(0.1)*randn(2,100);
% xx(:,201:300)=sqrt(0.2)*rand(2,100);
% for i=1:100
%     xx(:,i)=xx(:,i)+mu1;
% end
% for i=101:200
%     xx(:,i)=xx(:,i)+mu2;
% end
% for i=201:300
%     xx(:,i)=xx(:,i)+mu3;
% end
% yy(101:200)=1;
% yy(201:300)=2;
% % plot3(xx(1,1:100),xx(2,1:100),yy(1:100),'o');hold on;plot3(xx(1,101:200),xx(2,101:200),yy(101:200),'ro');
% yy=yy+1;
%  L=3;
max_D=Inf;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xx=scale(xx); % scale each dimension to [-1,1]
phir=0.3;%%%%%%%%
b=0.5; % f(neti)=tanh(b*neti)
[I N]=size(xx);
W=[eye(I,I) zeros(I,1);rand(L2-I,I+1)];
%W=2*rand(L2,I+1)-1;
gradient1=zeros(I,I+1);
mone=zeros(1,N);
mone(1,:)=-1;
% reordering the training data according to their class labels (ascending order)
[yy index]=sort(yy);
xx=xx(:,index);
num=zeros(1,L); % number of patterns within each class 
for i=1:N
    switch(yy(i))
        case (yy(i))
            num(yy(i))=num(yy(i))+1;
        otherwise
           disp('it is impossible')
   end
end
repind=zeros(L,L,2);

% initialize minimum distance matrix between classes
D=zeros(L,L);
D(:,:)=Inf;

minD=-Inf; % minimum inter-class distance
epoch=1;
tic
while ~(minD>=max_D) % while the desired condition has not reached
zz=tanh(b*W*[xx;mone]); % zz store network output
 %%% display network output %%
 if L2==2
      if (2<=L)&&(L<=4)
          switch(L)
              case 2
                  plot(zz(1,1:num(1)),zz(2,1:num(1)),'ro'); hold on;
                  plot(zz(1,num(1)+1:N),zz(2,num(1)+1:N),'b+');
                  pause(0.01);
                  hold off;
              case 3
                  plot(zz(1,1:num(1)),zz(2,1:num(1)),'ro'); hold on;
                  plot(zz(1,num(1)+1:num(1)+num(2)),zz(2,num(1)+1:num(1)+num(2)),'b+');
                  plot(zz(1,num(1)+num(2)+1:N),zz(2,num(1)+num(2)+1:N),'kd');
                  pause(0.01);
                  hold off;
              case 4
                  plot(zz(1,1:num(1)),zz(2,1:num(1)),'ro'); hold on;
                  plot(zz(1,num(1)+1:num(1)+num(2)),zz(2,num(1)+1:num(1)+num(2)),'b+');
                  plot(zz(1,num(1)+num(2)+1:num(1)+num(2)+num(3)),zz(2,num(1)+num(2)+1:num(1)+num(2)+num(3)),'kd');
                  plot(zz(1,num(1)+num(2)+num(3)+1:N),zz(2,num(1)+num(2)+num(3)+1:N),'gs');
                  pause(0.01);
                  hold off;
              otherwise
          end
      end
  end
  if L2==3
     if (2<=L)&&(L<=4)
          switch(L)
              case 2
                  plot3(zz(1,1:num(1)),zz(2,1:num(1)),zz(3,1:num(1)),'ro'); hold on;
                  plot3(zz(1,num(1)+1:N),zz(2,num(1)+1:N),zz(3,num(1)+1:N),'b+');
                  pause(0.01);
                  hold off;
              case 3
                  plot3(zz(1,1:num(1)),zz(2,1:num(1)),zz(3,1:num(1)),'ro'); hold on;
                  plot3(zz(1,num(1)+1:num(1)+num(2)),zz(2,num(1)+1:num(1)+num(2)),zz(3,num(1)+1:num(1)+num(2)),'b+');
                  plot3(zz(1,num(1)+num(2)+1:N),zz(2,num(1)+num(2)+1:N),zz(3,num(1)+num(2)+1:N),'kd');
                  pause(0.01);
                  hold off;
              case 4
                  plot3(zz(1,1:num(1)),zz(2,1:num(1)),zz(3,1:num(1)),'ro'); hold on;
                  plot3(zz(1,num(1)+1:num(1)+num(2)),zz(2,num(1)+1:num(1)+num(2)),zz(3,num(1)+1:num(1)+num(2)),'b+');
                  plot3(zz(1,num(1)+num(2)+1:num(1)+num(2)+num(3)),zz(2,num(1)+num(2)+1:num(1)+num(2)+num(3)),zz(3,num(1)+num(2)+1:num(1)+num(2)+num(3)),'kd');
                  plot3(zz(1,num(1)+num(2)+num(3)+1:N),zz(2,num(1)+num(2)+num(3)+1:N),zz(3,num(1)+num(2)+num(3)+1:N),'gs');
                  pause(0.01);
                  hold off;
              otherwise
          end
          end
  end
%%% swissroll.dat only
% plot3(zz(1,1:400),zz(2,1:400),zz(3,1:400),'o');
% hold on;
%  plot3(zz(1,401:800),zz(2,401:800),zz(3,401:800),'ro');
%  plot3(zz(1,801:1200),zz(2,801:1200),zz(3,801:1200),'go');
%  plot3(zz(1,1201:1600),zz(2,1201:1600),zz(3,1201:1600),'ko');
%  hold off;
%%%%%
% plot(zz(1,1:400),zz(2,1:400),'o');
% hold on;
%  plot(zz(1,401:800),zz(2,401:800),'ro');
%  plot(zz(1,801:1200),zz(2,801:1200),'go');
%  plot(zz(1,1201:1600),zz(2,1201:1600),'ko');
%  hold off;
 %%%%%%%%%
% Compute minD
% given class l, k-th pattern: global index in xx is sum(num(1:l-1))+k
repE=0;
  for i=1:L-1 % class i
      counteri=sum(num(1:i-1));
      for j=i+1:L % class j
         counterj=sum(num(1:j-1));   
         d=zeros(num(i),num(j));
         d(:,:)=Inf;
         for k=1:num(i)
             for h=1:num(j)
                 d(k,h)=sum((zz(:,counteri+k)-zz(:,counterj+h)).^2);
                 repE=repE+d(k,h);
             end
         end
         [v in]=min(d);[v2 h]=min(v);g=in(h);
         D(i,j)=v2;
         repind(i,j,1)=counteri+g; repind(i,j,2)=counterj+h;
     end
  end
% minD=sqrt(min(min(D))); 
[v in]=min(D);[v2 c2]=min(v); c1=in(c2); 
minD=sqrt(v2);

repE=-.5*repE; 
  if toc>5       
       [epoch]
       [repE]
       %[maxD]
       %[minD]
       tic
  end
% start one epoch 
%% Minimize two classes with closest distance c1, c2
         p1=repind(c1,c2,1);
         p2=repind(c1,c2,2);
           %%%%%%%%%%% Minimize repellence energy
             for i=1:L2
                yip1=zz(i,p1);
                yip2=zz(i,p2);
                for j=1:I
                    gradient1(i,j)=-b*(yip1-yip2)*((1-yip1^2)*xx(j,p1)-(1-yip2^2)*xx(j,p2));
                end
                j=I+1;
                   gradient1(i,j)=-b*(yip1-yip2)*(yip1^2-yip2^2);
             end
            %% update W
            W=W-phir*gradient1;
            %%%%%%%%%%%%%%%%%%%
         
epoch=epoch+1;
end % end while
   