function [m,expplot,EXP]=qLyapunov(xx,mode)
% function [m,expplot,EXP]=qLyapunov(xx,mode)

switch(mode)
    case 0
      load MIMOcwmmodel mux varx beta pcm;
    case 1
      load sseMIMO mux varx beta pcm;
   otherwise
    disp('mode has to be either 0 or 1');
end
% Specify xx, yy and M first
d=length(xx(:,1));
N=length(xx(1,:));
M=length(mux(1,:));
q=2*pi; sqi=(sqrt(q))^d;
 px_cm=zeros(N,M); 
 I=d; O=d;
 D=(I^2+3*I+2)/2;
 betaM=zeros(I,I,M,O);
 
 for o=1:O
   for m=1:M
    k=2*I+2; 
   for i=1:I-1
     for j=i+1:I
         betaM(i,j,m,o)=beta(k,m,o);
         betaM(j,i,m,o)=beta(k,m,o);
         k=k+1;
     end
   end
  end
end
 
 f=ones(D,N);
 for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
k=I+2;
for i=1:I
    for n=1:N
        f(k,n)=xx(i,n)*xx(i,n);
    end
    k=k+1;
end
k=2*I+2;
for i=1:I-1
    for j=i+1:I
        for n=1:N
            f(k,n)=xx(i,n)*xx(j,n);
        end
        k=k+1;
    end
end
 
 % Calculate px_cm
 for n=1:N
    for m=1:M
           Vxi=varx(:,m).^-1; 
           t=xx(:,n)-mux(:,m);
           t=t.^2;
           px_cm(n,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end
end
 
%  %%%%%%%% Jocobian %%%%%%%%%%%%%%%%
Df=zeros(d,d); 
 Q=eye(d);
 EXP=zeros(1,d);
 K=N;


for n=1:N
 % calculate Df(n)   
for i=1:d
   for j=1:d
       A=0; B=0; Ap=0; Bp=0;
       for m=1:M
           temp=px_cm(n,m)*pcm(m);
           A=A+f(:,n)'*beta(:,m,i)*temp;
           B=B+temp;

          px_cmp=-px_cm(n,m)*((xx(j,n)-mux(j,m))/varx(j,m));
          Ap=Ap+(beta(j+1,m,i)+beta(d+1+j,m,i)*2*xx(j,n)+betaM(j,:,m,i)*xx(:,n))*px_cm(n,m)*pcm(m)+f(:,n)'*beta(:,m,i)*px_cmp*pcm(m);
          Bp=Bp+px_cmp*pcm(m);
      end
          
      Df(i,j)=(Ap*B-Bp*A)/B^2;
  end
end

[Q R]=qr(Df*Q);
 EXP=EXP+log(diag(abs(R)))';
 expplot(n)=max(EXP)/n;
end  % end of for n=1:N

%%% Evaluate finite-time Lyapunov exponent
EXP=EXP/K;
m=max(EXP);  % Calculate the maximal Lyapunov exponent among all d dimensions 

