%function sseMIMOltr(xx,yy)
% function sseMIMOltr(xx,yy)
% sseMIMO Linear local model
% Minimizing Sum of Squared Error , CWM linear local model
% Specify the value of min_E
min_E=0; 
niter=100;

load MIMOcwmmodel model mux varx vary beta pcm ; % LOAD CWM's Training Result

%load sseMIMO model mux varx muy vary beta pcm;

O=length(yy(:,1));
[I,N]=size(xx);
M=length(mux(1,:));
MUY=zeros(N,M,O);
muy2=zeros(N,O);
%Atemp=ones(I,M);
%beta=zeros(I+1,M,O);%%%%%
%Atemp2=ones(1,M);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing vary
for i=1:O
    miny(i)=min(yy(i,:));
    maxy(i)=max(yy(i,:));
end
 for m=1:M
    vary(:,m)=(maxy-miny)';
 end
%%%%%%%%%%%%%%%%%%% Validation set %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [It,Nt]=size(vx);
% ft=ones(I+1,Nt);
% for i=2:(I+1)
%     for n=1:Nt
%         ft(i,n)=vx(i-1,n);
%     end
% end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
epsy=0;
%%
posteriors=zeros(N,M);
%betacurve=zeros(I+1,2000,M);
%%
f=ones(I+1,N);
q=2*pi;
sq=sqrt(q);
sqi=sq^I;
sqo=sq^O;
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
%%%%%
 muy=zeros(O,1);
 no=zeros(1,O);
 e=zeros(1,O);
 muyp=zeros(O,M);
%%%%% 
for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end

 SDx=sqrt(varx); Z=log(pcm);
phi=.01; phi2=0.01; phisd=0.001;phipr=0.01; % notice phi !
%%%%%%%%%%%%%%%%%%%%%%%%%%varx update change %%%%%%%%%%%%%%%
MSE=777; 
epoch=1;
msecurve=[];
like=[];
trackcount=1;

while MSE>min_E %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%while epoch<=niter %% choose one line to comment
MSE=0;   
%%%%%%% Calculating gradients --- sequential learning --- %%%
% feed-forward process
%Seq=randperm(N); %%%% here comes the randomness ~
Seq=linspace(1,N,N); % For time-series dynamical system
for n=1:N
    j=Seq(n);
  for m=1:M
           Vxi=varx(:,m).^-1; 
           t=xx(:,j)-mux(:,m);
           t=t.^2;
            px_cm(j,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end   
    de=px_cm(j,:)*pcm';
     
   y_x=zeros(O,1);
 for d=1:O   
     muyp(d,:)=f(:,j)'*beta(:,:,d);
     y_x(d)=sum(muyp(d,:).*px_cm(j,:).*pcm);
  
     no(d)=y_x(d);
     y_x(d)=y_x(d)/de;
     e(d)=yy(d,j)-y_x(d);
      
       MSE=MSE+e(d)^2;
 end
    %%%%%%%%% Calculating gradients (backward process) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 gradientMx=zeros(I,M);  gradientSDx=zeros(I,M); 
gradientP=zeros(1,M); gradientbeta=zeros(I+1,M,O);
gradientZ=zeros(1,M);
% %%% This version runs faster...
for d=1:O
    for m=1:M
        for i=1:I
            g=(xx(i,j)-mux(i,m))/SDx(i,m)^2;
            gradientMx(i,m)=gradientMx(i,m)-e(d)*pcm(m)*px_cm(j,m)*g*(muyp(d,m)*de-no(d))/de^2;
        end
  
        for i=1:I  
            g2=((xx(i,j)-mux(i,m))^2/SDx(i,m)^3)-1/SDx(i,m);
             gradientSDx(i,m)=gradientSDx(i,m)-e(d)*pcm(m)*px_cm(j,m)*g2*(muyp(d,m)*de-no(d))/de^2;
        end
        
        for i=1:I+1
            gradientbeta(i,m,d)=-e(d)*px_cm(j,m)*pcm(m)*f(i,j)/de;
        end
        
        gradientP(m)=gradientP(m)-e(d)*px_cm(j,m)*(muyp(d,m)*de-no(d))/de^2;
    end
end
%% This version is slower...call too many repmat()?
% g=(repmat(xx(:,j),1,M)-mux)./SDx.^2;
% g2=(((repmat(xx(:,j),1,M)-mux).^2)./SDx.^3)-SDx.^-1;
%  for d=1:O
%   gradientMx=gradientMx-e(d)*(repmat(pcm,I,1).*repmat(px_cm(j,:),I,1).*g.*((repmat(muyp(d,:),I,1)*de-ones(I,M)*no(d))/de^2));
%    gradientSDx=gradientSDx-e(d)*(repmat(pcm,I,1).*repmat(px_cm(j,:),I,1).*g2.*((repmat(muyp(d,:),I,1)*de-ones(I,M)*no(d))/de^2));
%   gradientbeta(:,:,d)=-e(d)*((repmat(px_cm(j,:),I+1,1).*repmat(pcm,I+1,1).*repmat(f(:,j),1,M)))/de;
%   gradientP=gradientP-e(d)*((px_cm(j,:).*(muyp(d,:)*de-ones(1,M)*no(d))))/de^2;
%  end

  gradientZ=gradientP.*(pcm-pcm.^2);
%%% updating parameters %%%
mux=mux-phi*gradientMx;
   SDx=SDx-phisd*gradientSDx;
      varx=SDx.^2;
   beta=beta-phi2*gradientbeta;

     Z=Z-phipr*gradientZ; 
     pcm=exp(Z)./sum(exp(Z));
end % end of n=1:N
% %%%%%%%%%%%%%%%% MSE ON Validation SET (Early stopping) %%%%%%%%%%%%%%%
% MSEt=0;
% Seqt=linspace(1,Nt,Nt);
% for n=1:Nt
%     j=Seqt(n);
%   for m=1:M
%            Vxi=varx(:,m).^-1; 
%            t=vx(:,j)-mux(:,m);
%            t=t.^2;
%            px_cmt(m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
%     end   
%   de=0; 
%      for m=1:M
%          de=de+px_cmt(m)*pcm(m);
%      end
%      
%    y_xt=zeros(O,1);
%  for d=1:O   
%      for m=1:M 
%          muyp(d,m)=ft(:,j)'*beta(:,m,d);
%      end
%     
%      for m=1:M
%          y_xt(d)=y_xt(d)+muyp(d,m)*px_cmt(m)*pcm(m);
%      end
%      not(d)=y_xt(d);
%      y_xt(d)=y_xt(d)/de;
%      et(d)=vy(d,j)-y_xt(d);
%       
%        MSEt=MSEt+et(d)^2;
%  end
% end
% MSEt=MSEt/Nt;  % MSE on validation set
% msecurve(epoch)=sqrt(MSEt);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MSE=MSE/N;  % MSE on training set
msecurve(epoch)=sqrt(MSE); % RMSE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  %  After one epoch, draw the likelihood value
for n=1:N
    for m=1:M
        for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
        end
          Vyi=vary(:,m).^-1; 
          t2=yy(:,n)-muy; 
          t2=t2.^2;
          
          div=(sqrt(prod(vary(:,m)))*(sqo));
          if div<realmin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
              div=realmin;
          end
          py_xcm(n,m)=exp(-t2'*Vyi*0.5)/div; %%% 
    end
end
      %% calculate log likelihood
   like(epoch)= sum(log((py_xcm.*px_cm)*pcm')); 
       
  %% update (estimate) vary by using EM (could still maximize likelihood function) %%
  % E-step
    posteriors=py_xcm.*px_cm.*(repmat(pcm,N,1));
posteriors=posteriors./(repmat(sum(posteriors,2),1,M));
   % M-step
   s=sum(posteriors);
for i=1:O
MUY(:,:,i)=f'*beta(:,:,i);
end
for m=1:M
    for i=1:O
     muy2(:,i)=MUY(:,m,i);
   end
vary(:,m)=((yy-muy2').^2)*posteriors(:,m)./(repmat(s(m),O,1));
end
vary=vary+ones(O,M)*epsy;
%%% plot curve %%%%
subplot(2,1,1);
plot(msecurve,'b');
subplot(2,1,2);
plot(like,'r')
pause(0.01);
%%%%%%%%%%%%%%%%%%
  epoch=epoch+1;
end  % End of while 
save sseMIMO model mux varx muy vary beta pcm like% track2;