%function sseMIMOqtr(xx,yy)
% function sseMIMOqtr(xx,yy)
% sseMIMO quardratic local model
% Minimizing Sum of Squared Error , CWM linear local model
% Specify the value of min_E
min_E=0; 
niter=180;

load MIMOcwmmodel model mux varx vary beta pcm muy like;
%load sseMIMO model mux varx muy vary beta pcm;

O=length(yy(:,1));
[I,N]=size(xx);
M=length(mux(1,:));
D=(I^2+3*I+2)/2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing vary
for i=1:O
    miny(i)=min(yy(i,:));
    maxy(i)=max(yy(i,:));
end
 for m=1:M
    vary(:,m)=(maxy-miny)';
 end
epsy=0;
%%
msecurve=[];
posteriors=zeros(N,M);
like=[];
f=ones(D,N);
q=2*pi;
sq=sqrt(q);
sqi=sq^I;
sqo=sq^O;
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
%%%%%
 muy=zeros(O,1);
 no=zeros(1,O);
 e=zeros(1,O);
 muyp=zeros(O,M);
%%%%%%%%% initialize f
for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
k=I+2;
for i=1:I
    for n=1:N
        f(k,n)=xx(i,n)*xx(i,n);
    end
    k=k+1;
end
k=2*I+2;
for i=1:I-1
    for j=i+1:I
        for n=1:N
            f(k,n)=xx(i,n)*xx(j,n);
        end
        k=k+1;
    end
end

 SDx=sqrt(varx); Z=log(pcm);
phi=1e-2;; phi2=1e-2; phi3=1e-3;phipr=1e-2; % notice phi !
%%%%%%%%%%%%%%%%%%%%%%%%%%varx update change %%%%%%%%%%%%%%%
MSE=777; 
%min_E=1e-6;
epoch=1;
tic
while MSE>min_E %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%while epoch<=niter  %% choose one line to comment
MSE=0;   
%%%%%%% Calculating gradients --- sequential learning --- %%%
% feed-forward process
%Seq=randperm(N); %%%% here comes the randomness ~
Seq=linspace(1,N,N);
for n=1:N
    j=Seq(n);
  for m=1:M
           Vxi=varx(:,m).^-1; 
           t=xx(:,j)-mux(:,m);
           t=t.^2;
           px_cm(j,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end   
  de=0; 
     for m=1:M
         de=de+px_cm(j,m)*pcm(m);
     end
     
   y_x=zeros(O,1);
 for d=1:O   
     for m=1:M 
         muyp(d,m)=f(:,j)'*beta(:,m,d);
     end
    
     for m=1:M
         y_x(d)=y_x(d)+muyp(d,m)*px_cm(j,m)*pcm(m);
     end
     no(d)=y_x(d);
     y_x(d)=y_x(d)/de;
     e(d)=yy(d,j)-y_x(d);
      
       MSE=MSE+e(d)^2;
 end
    %%%%%%%%% Calculating gradients (backward process) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
gradientMx=zeros(I,M);  gradientSDx=zeros(I,M); 
gradientP=zeros(1,M); gradientbeta=zeros(D,M,O);
gradientZ=zeros(1,M);
for d=1:O
    for m=1:M
        for i=1:I
            g=(xx(i,j)-mux(i,m))/SDx(i,m)^2;
            gradientMx(i,m)=gradientMx(i,m)-e(d)*pcm(m)*px_cm(j,m)*g*(muyp(d,m)*de-no(d))/de^2;
        end
        for i=1:I  
            g2=((xx(i,j)-mux(i,m))^2/SDx(i,m)^3)-1/SDx(i,m);
            gradientSDx(i,m)=gradientSDx(i,m)-e(d)*pcm(m)*px_cm(j,m)*g2*(muyp(d,m)*de-no(d))/de^2;
        end
        
        for i=1:D
            gradientbeta(i,m,d)=-e(d)*px_cm(j,m)*pcm(m)*f(i,j)/de;
        end
   
        gradientP(m)=gradientP(m)-e(d)*px_cm(j,m)*(muyp(d,m)*de-no(d))/de^2;
    end
end
  gradientZ=gradientP.*(pcm-pcm.^2);
%%% updating parameters %%%
mux=mux-phi*gradientMx;
    SDx=SDx-phi2*gradientSDx;
   beta=beta-phi*gradientbeta;
      Z=Z-phipr*gradientZ; 
       pcm=exp(Z)./sum(exp(Z));
      varx=SDx.^2;
end % end of n=1:N


 %  After one epoch, draw the likelihood value
for n=1:N
    for m=1:M
        for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
        end
          Vyi=vary(:,m).^-1; 
          t2=yy(:,n)-muy; %%% very close to zero...
          t2=t2.^2;
          
          div=(sqrt(prod(vary(:,m)))*(sqo));
%           if div<realmin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               div=realmin;
%           end
          py_xcm(n,m)=exp(-t2'*Vyi*0.5)/div; %%% why zero?
    end
end
      %% calculate log likelihood
   like(epoch)= sum(log((py_xcm.*px_cm)*pcm')); 
  %% update (estimate) vary by using EM (could still maximize likelihood function) %%
  % E-step
    posteriors=py_xcm.*px_cm.*(repmat(pcm,N,1));
posteriors=posteriors./(repmat(sum(posteriors,2),1,M));
   % M-step
   s=sum(posteriors);
for i=1:O
  for m=1:M
         temp3=0;    
        for n=1:N
         muy(i)=f(:,n)'*beta(:,m,i);
         temp3=temp3+(yy(i,n)-muy(i))*(yy(i,n)-muy(i))*posteriors(n,m);
        end
        if s(m)<realmin     %%%%%%%%%%%%%%%%%%%%%
            s(m)=realmin;
        end
      vary(i,m)=epsy+temp3/s(m); 
   end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MSE=MSE/N;
msecurve(epoch)=sqrt(MSE);
%%% plot curve %%%%
subplot(2,1,1);
plot(msecurve,'b');
subplot(2,1,2);
plot(like,'r')
pause(0.01);
%%%%%%%%%%%%%%%%%%
  epoch=epoch+1;
end  % End of while 
save sseMIMO model mux varx muy vary beta pcm;