function [mux,varx,beta,pcm,vary,likelihood] = MIMOcwml(xx,yy,M,iter,epsx,epsy)
% function [mux,varx,beta,pcm,vary,likelihood] = MIMOcwml(xx,yy,M,iter,epsx,epsy)

[I N]=size(xx);
O=length(yy(:,1));
mux=zeros(I,M);
varx=zeros(I,M);
muy=zeros(O,1);
vary=zeros(O,M);
beta=zeros(I+1,M,O);
q=2*pi;
sq=sqrt(q);
sqi=sq^I;
sqo=sq^O;
f=ones(I+1,N);
minx=zeros(1,I); % to store the minimum of each input dimension
maxx=zeros(1,I); % to store the maximum of each input dimension
miny=zeros(1,O);
maxy=zeros(1,O);

px_cm=zeros(N,M);
py_xcm=zeros(N,M);
posteriors=zeros(N,M);
pcm=zeros(1,M);
B=zeros(I+1,I+1);
a=zeros(I+1,1);
% parameters initialization
for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
for i=1:I
    minx(i)=min(xx(i,:));
    maxx(i)=max(xx(i,:));
end
for i=1:O
    miny(i)=min(yy(i,:));
    maxy(i)=max(yy(i,:));
end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing varx vary
 for m=1:M
    varx(:,m)=(maxx-minx)';
    vary(:,m)=(maxy-miny)';
 end
% use k-means to initialize cluster centers
[idx c]=kmeans(xx',M);
mux=c';
pcm(1,:)=1/M;
it=linspace(1,iter,iter);
like=zeros(1,iter); %%%%%
MSE=zeros(1,iter);
epoch=1;
% Start training
while(epoch<=iter)
 % E-Step
 %%%% draw %%%%%%%%%%%%%%%%%%%%%%
% if I==2
% subplot(2,1,1);
%     for m=1:M
%          mu=mux(:,m); 
%              temp=diag(varx(:,m));
%              tempi=varx(:,m).^-1;
%              p=exp(-0.5*(tempi(1)*(x1-mu(1)).^2+tempi(2)*(x2-mu(2)).^2))/(sqrt((2*pi).^2)*sqrt(det(temp)))*pcm(m); % p(x,cm)
%              hold on;
%              surf(x1,x2,p);
%              axis tight;
%              hold off;
%          end
%     % pause(0);
%       %pause
%    end
% if I==1
%     temp=0;
%     hold off;
%     subplot(2,1,1);
%     for m=1:M
%         p=pcm(m)*exp(-0.5*(xplot-mux(m)).^2/varx(m))/(sqrt(2*pi*varx(m)));
%         plot(xplot,p);
%         hold on
%      end
%    pause(0);     
%    %pause
% 
% end % end if
% hold off;
 %%%%%%%%%%% End of drawing %%%%%%%%%%%%%%%%%%%%%
for n=1:N
    for m=1:M
%          Vx=diag(varx(:,m));
%          Vxi=diag(varx(:,m).^-1);
%          px_cm(n,m)=exp(-(xx(:,n)-mux(:,m))'*Vxi*(xx(:,n)-mux(:,m))*0.5)/(sqrt(det(Vx))*(sq^I));
           Vxi=varx(:,m).^-1; 
           t=xx(:,n)-mux(:,m);
           t=t.^2;
           px_cm(n,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end
end
for n=1:N
    for m=1:M
%         Vy=diag(vary(:,m));
%         Vyi=diag(vary(:,m).^-1);
        for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
        end
%         py_xcm(n,m)=exp(-(yy(:,n)-muy)'*Vyi*(yy(:,n)-muy)*0.5)/(sqrt(det(Vy))*(sq^O));
          Vyi=vary(:,m).^-1; 
          t2=yy(:,n)-muy;
          t2=t2.^2;
          py_xcm(n,m)=exp(-t2'*Vyi*0.5)/(sqrt(prod(vary(:,m)))*(sqo));
    end
end

    for n=1:N
           temp2=0;
        for m=1:M
        temp2=temp2+py_xcm(n,m)*px_cm(n,m)*pcm(m);
        end
        for m=1:M
            posteriors(n,m)=py_xcm(n,m)*px_cm(n,m)*pcm(m)/temp2;
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% M-step
 s=sum(posteriors);
 pcm=s/N;

 for m=1:M
     mu=zeros(I,1);
     for n=1:N
     mu=mu+xx(:,n)*posteriors(n,m);
     end
   mux(:,m)=mu/s(m);
end
for m=1:M
   for i=1:I 
          temp3=0;
        for n=1:N
            temp3=temp3+(xx(i,n)-mux(i,m))*(xx(i,n)-mux(i,m))*posteriors(n,m);
        end
      varx(i,m)=epsx+temp3/s(m); 
      end
end
% for k=1:O
for m=1:M
%  calculate  [Bij] [a]
      for i=1:I+1
          for j=1:I+1
                 temp3=0;
              for n=1:N
                  temp3=temp3+f(i,n)*f(j,n)*posteriors(n,m);
              end
              B(i,j)=temp3/s(m)+epsx; %%%%%%%%%%%%%%%%%% eps for stability %%%%%%%%%%
          end
      end
      %  beta=inv(B)*a;
 %% update beta USING SVD %%
       [U,W,V]=svd(B);           
        W=diag(diag(W).^-1);
        B=V*W*U';
   for k=1:O
       for i=1:I+1
              temp3=0;
               for n=1:N
                  temp3=temp3+yy(k,n)*f(i,n)*posteriors(n,m);
               end
              a(i)=temp3/s(m);
        end
%  %  beta=inv(B)*a;
%  %% update beta USING SVD %%
%        [U,W,V]=svd(B);           
%         W=diag(diag(W).^-1);
%         B=V*W*U';
        beta(:,m,k)=B*a;
   end
end

for i=1:O
  for m=1:M
         temp3=0;    
        for n=1:N
         muy(i)=f(:,n)'*beta(:,m,i);
         temp3=temp3+(yy(i,n)-muy(i))*(yy(i,n)-muy(i))*posteriors(n,m);
        end
      vary(i,m)=epsy+temp3/s(m); 
   end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%5
   % calculate log likelihood
      loglikeli=0;
    for n=1:N
      temp=0;
        for m=1:M
         temp=temp+px_cm(n,m)*py_xcm(n,m)*pcm(m);
        end 
        loglikeli=log(temp)+loglikeli;
    end   
         like(epoch)=loglikeli;
         
      subplot(2,1,2);
     plot(it,like,'r');
     pause(0)
 %%%%%%%%%%%%%%%%%%%%%
 % calculate MSE
  % calculate <y_x>
    y_x=zeros(O,N);
   for n=1:N
     temp2=0;
     for m=1:M
         temp2=temp2+px_cm(n,m)*pcm(m);
         for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
         end
       y_x(:,n)=y_x(:,n)+muy*px_cm(n,m)*pcm(m);
     end
     y_x(:,n)=y_x(:,n)/temp2;
 end
    E=0;
   for i=1:N
       E=E+sum((y_x(:,i)-yy(:,i)).^2);
   end
   MSE(epoch)=sqrt(E/N);
   subplot(2,1,1);
   plot(it,MSE,'b');
   %%%%%%%%%%%%%%%%%%%%%%
epoch=epoch+1;
end
likelihood=like(iter);