%function bpcwm(xx,yy,min_E)
% function bpcwm(xx,yy,min_E)  
% specify the value of min_E before running this program       

load cwmmodel model mux varx muy vary beta pcm betaq;

[I,N]=size(xx);
O=length(yy(:,1));
M=length(mux(1,:,1));
Tar=zeros(1,M); % M by N by O
Pat=linearf(xx);
L1=length(Pat(:,1));% input layer dimension 
L2=length(mux(1,:,:));
y_x=zeros(1,N);
Phi=0.001;
phi1=0.01;
phi2=0.001;
phi3=0.0001;
gradientZ=zeros(1,M);gradientB=zeros(1,M);gradientM=zeros(I,M);gradientV=zeros(I,I,M);
gradientSD=zeros(1,M);
px_cm=zeros(1,M);
wm=zeros(1,M);
q=2*pi;  
net.W1=beta(:,:)';
msecurve=zeros(1,2000);
SDx=sqrt(varx);
%netE.W1=pcm(1,:);
Z=log(pcm);
bias=rand(1,M);
MSE=777;
epoch=1; %%%% notice
%%%  
%load bpcwmtemp net mux varx pcm bias msecurve; 
%%%

tic
while MSE>min_E
  Seq=randperm(N);

 for n=1:N     % one epoch starts  
      j=Seq(n);
% feed-forward process of netB
    for m=1:M
         mu=mux(:,m); 
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cm(m)=exp(-(xx(:,j)-mu)'*tempi*(xx(:,j)-mu)*0.5)/(sqrt(det(temp))*(sqrt(q)^I));
    end
  ppcm=px_cm.*pcm; 
  s=sum(ppcm);
  wm=ppcm/s;
  net.W2=wm; 

        [Y,y]=cwmforward(net,Pat(:,j));  % output
        D=yy(j);  % desire response
        e=D-Y;
 % backward process of netB       
        % Calculate delta
        %delta2= e*(1-Y)*Y ;  % this is sigmoid neuron
        delta2 = e*1 ;
        w=net.W2(1,1:L2) ;
        delta1=delta2 * w';
      
        % update output neuron
        net.W2 = net.W2 + phi1*delta2*[y'];
        % update hidden neuron
        for i=1: (L2)
            net.W1(i,:) = net.W1(i,:) + phi1*delta1(i) * [Pat(:,1)'];
        end  
        Tar=net.W2;
   % adjust Tar and normalize them without any mathematic formulas, here is the biggest problem.
        for i=1:M
            if Tar(i)<0
                Tar(i)=0;
            end
            if Tar(i)>1
                Tar(i)=1;
            end
        end
        Tar=Tar/sum(Tar);
        net.W2=Tar;
%%%%%%%%%%%% netE %%%%%%%%%%%%%%
% feed-forward process of netE
       Y2=logsig(ppcm+bias);  % output
%         Y 
%         pause; 
       % D=Tar;  % desired response
        e2=Tar-Y2;
        % Calculate gradient
        gradientZ =-e2.*Y2.*(1-Y2).*px_cm.*(pcm-pcm.^2);
        gradientB= -e2.*Y2.*(1-Y2);
        for m=1:M
          tempi=diag(varx(:,m).^-1);
          gradientM(:,m) = -(e2(m)*Y2(m)*(1-Y2(m))*pcm(m)*px_cm(m)*tempi*(xx(:,j)-mux(:,m)));                     
        end
        for m=1:M
           
                %gradientV(i,m)=-0.5*e2(m)*Y2(m)*(1-Y2(m))*pcm(m)*px_cm(m)*((1/varx(i,m))+((xx(i,j)-mux(i,m)).^2/2*varx(i,m).^2));
          gradientV(:,:,m)=(e2(m)*Y2(m)*(1-Y2(m))*pcm(m)*px_cm(m)*(xx(:,j)-mux(:,m))*(xx(:,j)-mux(:,m))');
          gradient(:,m)=diag(gradientV(:,:,m));
        end
%%%%%%%%%%%%%%%%%%%%%
%        for m=1:M
%            for i=1:I
%                gradientM(i,m)=-e2(m)*Y2(m)*(1-Y2(m))*pcm(m)*px_cm(m)*((xx(i,j)-mux(i,m))/varx(i,m));
%            end
%        end
%        
%       for m=1:M
%            for i=1:I
%                 SD=SDx(i,m);
%                gradientSD(i,m)=-e2(m)*Y2(m)*(1-Y2(m))*pcm(m)*px_cm(m)*((-1/SD)+((xx(i,j)-mux(i,m))^2/SD^3));
%            end
%        end
%%%%%%%%%%%%%%%%%
   % backward process of netE     
        Z=Z-phi1*gradientZ;
        pcm=exp(Z)./sum(exp(Z));
        bias=bias-phi1*gradientB;
        mux=mux-phi1*gradientM;
     
        iV=varx.^-1;
        gradient(:,m)=diag(gradientV(:,:,m));
        iV=iV-phi2*gradient;
        varx=iV.^-1;
%%%%%%%%%%
%         SDx=SDx-phi1*gradientSD;
%         varx=SDx.^2;
 %%%%%%%%%       
    end  % End of one epoch
   % Calculate MSE after each epoch
   %%%%%%%%%%%%%%%%
     for n=1:N
%      feed-forward of netE
        for m=1:M
         mu=mux(:,m); 
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cm(m)=exp(-(xx(:,n)-mu)'*tempi*(xx(:,n)-mu)*0.5)/(sqrt(det(temp))*(sqrt(q)^I));
       end
       ppcm=px_cm.*pcm;  
       out=logsig(ppcm+bias);
       net.W2=out;
       [y_x(n),y]=cwmforward(net,Pat(:,n));
     end
     %%%%%%%%%%%%%%%%%%%
   Err=0;
   for n=1:N
       Err=Err+(y_x(n)-yy(n))^2;
   end
   MSE=sqrt(Err/N);
   msecurve(epoch)=MSE;
   if toc>10
       [MSE]
       [epoch]
      % save bpcwmtemp net mux varx pcm bias msecurve;
       tic
   end
epoch=epoch+1;
end   % End of while    

save bpcwm net mux varx pcm bias msecurve;