
function [mux,varx,beta,pcm,vary,likelihood] = cwmlinear(xx,yy,M,iter,epsx,epsy)
%function [mux,varx,beta,pcm,vary,likelihood] = cwmlinear(xx,yy,M,iter,epsx,epsy)

warning on MATLAB:singularMatrix
% Multidimensional input to scaler output CWM EM training
[I N]=size(xx);% input dimension I

q=2*pi;
sq=sqrt(q);
sqi=sq^I;
error=Inf; %%%%%% output error talerance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
minval=zeros(1,I); % to store the minimum of each input dimension
maxval=zeros(1,I); % to store the maximum of each input dimension
mux=zeros(I,M);
muy=zeros(N,M); %%% muy=f(x,bm) %%%%
beta=zeros(I+1,M);
y_x=zeros(1,N);
f=ones(I+1,N); %%%%%  local model fj=(xx)j or ... 
varx=ones(I,M);
vary = ones(1,M);        % y variance l1 
pcm=zeros(1,M);
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
posteriors=zeros(N,M);
temp=zeros(I,I);
tempi=zeros(I,I);
% Initailization %
for i=1:I
    minval(i)=min(xx(i,:));
    maxval(i)=max(xx(i,:));
end
 miny=min(yy);
 maxy=max(yy);
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing varx vary
 for m=1:M
for i=1:I
        varx(i,m)=maxval(i)-minval(i);
end
%muy(m)=(maxy-miny)*rand+miny;
end
 vary(1,:)=maxy-miny;
%varx(:,:)=0.02;% vary(1,:)=0.02;
%%%%%%%%%%%%%%%%%%%%%%%%%%%
% use k-means to initialize cluster centers
[idx c]=kmeans(xx',M);
mux=c';
pcm(:)=1/M;


%load cwminit mux varx vary;
% load ssecwm mux varx beta pcm;
 %%% failure mode %%
%  pcm(1)=0.062401; pcm(2)=0.46941; pcm(3)=0.46818; pcm(4)=6.2381e-007;
%  mux(:,1)=[0.016962;-0.0013557]; mux(:,2)=[-0.99309;-1.0045]; mux(:,3)=[1.0073;1.0034]; mux(:,4)=[-1.0012;-1.0012];
%  varx(:,1)=[.99358;1.0358]; varx(:,2)=[.038252;.040611]; varx(:,3)=[.040594;.036923];varx(:,4)=[.015674;.01295];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% load ssecwm_temp muxs varxs betas pcms;
% mux=muxs;varx=varxs;beta=betas;pcm=pcms;
%%%%%%%%% initialize fj 
for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
%%%%%%%%%%%%%%%% drawing space %%%%%%
% nplot=40;
% if I==1
% xplot=linspace(minval(1),maxval(1),nplot);
% end
% 
% if I==2
%     xplot1=linspace(minval(1),maxval(1),nplot);
%     xplot2=linspace(minval(2),maxval(2),nplot);
%     [x1,x2]=meshgrid(xplot1,xplot2);
%    
% end
%     
%%%%%%%%%%%%%%%%
it=linspace(1,iter,iter);
like=zeros(1,iter); %%%%%
MSE=zeros(1,iter);
%betacurve=zeros(I+1,iter,M);
% Start Training % 
step=1;

while (step<=iter) % run iterations
 % E-Step
 %%%% draw %%%%%%%%%%%%%%%%%%%%%%
% if I==2
% subplot(2,1,1);
%     for m=1:M
%          mu=mux(:,m); 
%              temp=diag(varx(:,m));
%              tempi=varx(:,m).^-1;
%              p=exp(-0.5*(tempi(1)*(x1-mu(1)).^2+tempi(2)*(x2-mu(2)).^2))/(sqrt((2*pi).^2)*sqrt(det(temp)))*pcm(m); % p(x,cm)
%              hold on;
%              surf(x1,x2,p);
%              axis tight;
%              hold off;
%          end
%     % pause(0);
%       %pause
%    end
% if I==1
%     temp=0;
%     hold off;
%     subplot(2,1,1);
%     for m=1:M
%         p=pcm(m)*exp(-0.5*(xplot-mux(m)).^2/varx(m))/(sqrt(2*pi*varx(m)));
%         plot(xplot,p);
%         hold on
%      end
%    pause(0);     
%    %pause
% 
% end % end if
% hold off;
 %%%%%%%%%%% End of drawing %%%%%%%%%%%%%%%%%%%%%
for n=1:N
    for m=1:M
         Vxi=varx(:,m).^-1; 
         t=xx(:,n)-mux(:,m);
         t=t.^2;
         px_cm(n,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end
end
for n=1:N
    for m=1:M
        temp2=1/vary(m);
        py_xcm(n,m)=exp(-(yy(n)-muy(n,m))*temp2*(yy(n)-muy(n,m))*0.5)/(sqrt(vary(m))*sq);
    end
end

    for n=1:N
           temp2=0;
        for m=1:M
        temp2=temp2+py_xcm(n,m)*px_cm(n,m)*pcm(m);
        end
        for m=1:M
            posteriors(n,m)=py_xcm(n,m)*px_cm(n,m)*pcm(m)/temp2; % Expectated posteriors
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % M-Step
    
   for m=1:M
       temp2=0;
       for n=1:N
           temp2=temp2+posteriors(n,m);
       end
       mu=zeros(I,1);
       for n=1:N
           mu=mu+xx(:,n)*posteriors(n,m);
       end
      pcm(m)=temp2/N; % update pcm
      mux(:,m)=mu/temp2; % update mux
      for i=1:I 
          temp3=0;
        for n=1:N
            temp3=temp3+(xx(i,n)-mux(i,m))*(xx(i,n)-mux(i,m))*posteriors(n,m);
        end
      varx(i,m)=epsx+temp3/temp2; % update varx %%%%%%%%%%%%%%
      end
      %%%%%%%%%%%%%%%%% update beta[I+1][M]
      B=zeros(I+1,I+1);
      a=zeros(I+1,1);
   
      for i=1:I+1
          for j=1:I+1
                 temp3=0;
              for n=1:N
                  temp3=temp3+f(i,n)*f(j,n)*posteriors(n,m);
              end
              B(i,j)=epsx+temp3/temp2; %%%%%%%%%%%%%%%%%% eps for stability %%%%%%%%%%
          end
      end
      
      for i=1:I+1
             temp3=0;
              for n=1:N
                  temp3=temp3+yy(n)*f(i,n)*posteriors(n,m);
               end
              a(i)=temp3/temp2;
       end
 %  beta=inv(B)*a;
 %% update beta USING SVD %%
       [U,W,V]=svd(B);           
        W=diag(diag(W).^-1);
        B=V*W*U';
        beta(:,m)=B*a;
         
      for n=1:N
          muy(n,m)=f(:,n)'*beta(:,m);
      end
                
      temp3=0;
      for n=1:N
          temp3=temp3+(yy(n)-muy(n,m))*(yy(n)-muy(n,m))*posteriors(n,m);
      end
      vary(m)=epsy+temp3/temp2; % update vary %%%%%%%%%%%%
  end  
  %%%%%%%%%%% end of M-Step
 
  %%%%% cooperate with ssecwm %%%%
%   load cwmplot muxp;
%   muxp(:,:,step)=mux;
%    save cwmplot muxp;
% % 
% % save cwmmodelt mux varx beta pcm; 
% [step]
%    ssecwm2;
% load sseplot muxs;
% muxs(:,:,step)=mux;
% save sseplot muxs;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  
%%% cooperate with MLP %%%%
%  load cwmplot muxp;
%  muxp(:,:,step)=mux;
%   save cwmplot muxp
% 
% save cwmmodelt mux varx beta pcm; 
% omlpcwm;
% omlpcwm2;
% load cwmmodelt mux varx beta; % load the training results of MLP
 % calculate log likelihood
      loglikeli=0;
    for n=1:N
      temp=0;
        for m=1:M
         temp=temp+px_cm(n,m)*py_xcm(n,m)*pcm(m);
        end 
        loglikeli=log(temp)+loglikeli;
    end   
         like(step)=loglikeli;
         
      subplot(2,1,2);
     plot(it,like,'r');
    pause(0)
 %%%%%%%%%%%%%%%%%%%%%
 % calculate MSE
  % calculate <y_x>
%     y_x=zeros(1,N);
%     for n=1:N
%       temp2=0;
%        for m=1:M
%           temp2=temp2+px_cm(n,m)*pcm(m);
%       end
%       for m=1:M
%           y_x(n)=y_x(n)+muy(n,m)*px_cm(n,m)*pcm(m);
%       end
%       y_x(n)=y_x(n)/temp2;
%     end
%     E=0;
%    for i=1:N
%        E=E+(y_x(i)-yy(i))^2;
%    end
%    MSE(step)=sqrt(E/N);
%    subplot(2,1,1);
%      plot(it,MSE,'b');
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Record beta learning curve 
% betacurve(:,step,:)=beta;
%%%%%%%%%%%%%%
  step=step+1;
end % end of iteration
 %save betacurve MSE like;
likelihood=like(iter);