function [mux,varx,beta,pcm] = cwmquadratic(xx,yy,M,iter,epsx,epsy)
%function [mux,varx,beta,pcm] = cwmquadratic(xx,yy,M,iter,epsx,epsy)

warning on MATLAB:singularMatrix
% Multidimensional input to scaler output CWM EM training
%clear all;
[I N]=size(xx);% input dimension I
%D=I^2+I+1;
%D=2*I+1;
D=(I^2+3*I+2)/2;
q=2*pi;
error=Inf; %%%%%% output error talerance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
minval=zeros(1,I); % to store the minimum of each input dimension
maxval=zeros(1,I); % to store the maximum of each input dimension
mux=zeros(I,M);
muy=zeros(N,M); %%% muy=f(x,bm) %%%%
beta=zeros(D,M);
y_x=zeros(1,N);
f=ones(D,N); %%%%%  local model fj=(xx)j or ... 
varx=ones(I,M);
vary = ones(1,M);        % y variance l1 
pcm=zeros(1,M);
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
posteriors=zeros(N,M);
temp=zeros(I,I);
tempi=zeros(I,I);

% Initailization %
for i=1:I
    minval(i)=min(xx(i,:));
    maxval(i)=max(xx(i,:));
end
 miny=min(yy);
 maxy=max(yy);
 % use k-means to initialize cluster centers
[idx c]=kmeans(xx',M);
mux=c';
% for m=1:M
%    
% %     for i=1:I
% %     mux(i,m) = (maxval(i)-minval(i))*rand+minval(i); %%%%%%%%randomMclusters mean [min(x),max(x)]%%%%%%%%%
% %     end    
% muy(m)=(maxy-miny)*rand+miny; %%%%%%%%%%randomMclusters mean [min(yy),max(yy)]
% pcm(m)=1/M; 
% end
pcm(:)=1/M;
%%%%%%%%% initialize fj 
    
for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
% k=I+2;
% for i=1:I
%     for j=1:I
%        for n=1:N
%            f(k,n)=xx(i,n)*xx(j,n);
%        end
%              k=k+1;
%        end
%    end

k=I+2;
for i=1:I
    for n=1:N
        f(k,n)=xx(i,n)*xx(i,n);
    end
    k=k+1;
end
k=2*I+2;
for i=1:I
    for j=i+1:I
        for n=1:N
            f(k,n)=xx(i,n)*xx(j,n);
        end
        k=k+1;
    end
end
%varx(:,:)=0.02; vary(1,:)=0.02;
%%%%%%%%%%%%%%%% drawing space %%%%%%
% nplot=40;
% if I==1
% xplot=linspace(minval(1),maxval(1),nplot);
% end
% 
% if I==2
%     xplot1=linspace(minval(1),maxval(1),nplot);
%     xplot2=linspace(minval(2),maxval(2),nplot);
%     [x1,x2]=meshgrid(xplot1,xplot2);
% end
%%%%%%%%%%%%%%%%
it=linspace(1,iter,iter);
like=zeros(iter);

% Start Training % 
step=1;
while (step<iter) % run iterations
   % calculate log likelihood
%       loglikeli=0;
%      for m=1:M
%         for n=1:N
%          loglikeli=loglikeli+px_cm(n,m)*py_xcm(n,m)*pcm(m);
%         end 
%          like(step)=loglikeli;
%      end 
%       
%      subplot(2,1,2);
%      plot(it,like,'r');
%      pause(0)
%      %pause
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % E-Step
 %%%% draw %%%%%%%%%%%%%%%%%%%%%%
% if I==2
% subplot(2,1,1);
%     for m=1:M
%          mu=mux(:,m); 
%              temp=diag(varx(:,m));
%              tempi=varx(:,m).^-1;
%              p=exp(-0.5*(tempi(1)*(x1-mu(1)).^2+tempi(2)*(x2-mu(2)).^2))/(sqrt((2*pi).^2)*sqrt(det(temp)))*pcm(m); % p(x,cm)
%              hold on;
%              surf(x1,x2,p);
%              axis tight;
%              hold off;
%          end
%     % pause(0);
%       pause
%    end
% if I==1
%     temp=0;
%     hold off;
%     subplot(2,1,1);
%     for m=1:M
%         p=pcm(m)*exp(-0.5*(xplot-mux(m)).^2/varx(m))/(sqrt(2*pi*varx(m)));
%         plot(xplot,p);
%         hold on
%      end
%    %pause(0);     
%    pause
% 
% end % end if
% hold off;
 %%%%%%%%%%% End of drawing %%%%%%%%%%%%%%%%%%%%%
for n=1:N
    x=xx(:,n);
    for m=1:M
         mu=mux(:,m); 
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cm(n,m)=exp(-(x-mu)'*tempi*(x-mu)*0.5)/(sqrt(det(temp))*(sqrt(q)^I));
    end
end
for n=1:N
    for m=1:M
        temp2=1/vary(m);
        py_xcm(n,m)=exp(-(yy(n)-muy(n,m))*temp2*(yy(n)-muy(n,m))*0.5)/(sqrt(vary(m))*sqrt(q));
    end
end

    for n=1:N
           temp2=0;
        for m=1:M
        temp2=temp2+py_xcm(n,m)*px_cm(n,m)*pcm(m);
        end
        for m=1:M
            posteriors(n,m)=py_xcm(n,m)*px_cm(n,m)*pcm(m)/temp2; % Expectated posteriors
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % M-Step
    
   for m=1:M
       temp2=0;
       for n=1:N
           temp2=temp2+posteriors(n,m);
       end
       mu=zeros(I,1);
       for n=1:N
           mu=mu+xx(:,n)*posteriors(n,m);
       end
      pcm(m)=temp2/N; % update pcm
      mux(:,m)=mu/temp2; % update mux
      for i=1:I 
          temp3=0;
        for n=1:N
            temp3=temp3+(xx(i,n)-mux(i,m))*(xx(i,n)-mux(i,m))*posteriors(n,m);
        end
      varx(i,m)=epsx+temp3/temp2; % update varx %%%%%%%%%%%%%%
      end
      %%%%%%%%%%%%%%%%% update beta[D][M]
      B=zeros(D,D);
      a=zeros(D,1);
   
      for i=1:D
          for j=1:D
                 temp3=0;
              for n=1:N
                  temp3=temp3+f(i,n)*f(j,n)*posteriors(n,m);
              end
              B(i,j)=epsx+temp3/temp2; %%%%%%%%%%%%%%%%%% eps for stability %%%%%%%%%%
          end
      end
      
      for i=1:D
             temp3=0;
              for n=1:N
                  temp3=temp3+yy(n)*f(i,n)*posteriors(n,m);
               end
              a(i)=temp3/temp2;
       end
     
%       beta(:,m)=inv(B)*a;
       [U,W,V]=svd(B);            %% update beta USING SVD %%%%%%%%%%%%%%%%%%%%%
        W=diag(diag(W).^-1);
        B=V*W*U';
        beta(:,m)=B*a;
      
      for n=1:N
        muy(n,m)=f(:,n)'*beta(:,m);
      end
          
      temp3=0;
      for n=1:N
          temp3=temp3+(yy(n)-muy(n,m))*(yy(n)-muy(n,m))*posteriors(n,m);
      end
      vary(m)=epsy+temp3/temp2; % update vary %%%%%%%%%%%%
  end  %%% end of M-Step
  
 
step=step+1;
 %%%%%%%%%%%% conditional error%%%%%%%%%%%%%
 if (step==(iter-1)) % in the last iteration
   %%%%%%%%%%%%%%% prediction %%%%%%%%%
     y_x=zeros(1,N);
    for n=1:N
      temp2=0;
       for m=1:M
          temp2=temp2+px_cm(n,m)*pcm(m);
      end
      for m=1:M
          y_x(n)=y_x(n)+muy(n,m)*px_cm(n,m)*pcm(m);
      end
      y_x(n)=y_x(n)/temp2;
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   n=1;
   while n<=N
     if abs(yy(n)-y_x(n)) > error
         step=step-1; n=N+1;
     end
     n=n+1;
   end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%         
end % end of iteration
%likelihood=like(iter-1);

%%%% predict original training input data
% y_x=zeros(1,N);
% for n=1:N
%     temp2=0;
%     for m=1:M
%         temp2=temp2+px_cm(n,m)*pcm(m);
%     end
%     for m=1:M
%         y_x(n)=y_x(n)+muy(n,m)*px_cm(n,m)*pcm(m);
%     end
%     y_x(n)=y_x(n)/temp2;
% end
%%%%%%%%%%%%%%%%%%%%%%%%%%
% print training data
% print 2-d figure:
% if I==2
% xlabel('x1');
% ylabel('x2');
% zlabel('y');
% plot3(xx(1,:),xx(2,:),yy,'bo','MarkerSize',16); % draw the training data points
% hold on;
% plot3(xx(1,:),xx(2,:),y_x,'r+','MarkerSize',16);
% hold on;
% grid;
% hold off;
% end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % print 1-d figure:
% if I==1
% xlabel('x');
% ylabel('y');
% plot(xx,yy,'bo');
% hold on ;
% plot(xx,y_x,'r+');
% % hold on;
% % plot(x,predy,'k*');
% hold off;
% end